//'WWW''''''''''''''''''''''''''''''WW''''WW''''''''WW''''''''''WWW'''''''
//WW  W                             WW              WW           WW       
//WW     WWW WWWW W   WW  W WW  WWW WW    WW  WWWW WWWW     WWW  WW   WWW 
//WW    W WW WW WW W WWWW WW   W WW WW    WW WWW    WW     WW W  WW  W WW 
//WW  W W WW WW WW W WW   WW   W WW WW    WW   WWW  WW     WW    WW  W WW 
// WWW   WWW WW WW W  WWW WW    WWW WWWWW WW WWWW   WW      WWW WWWW  WWW 
//                                                                        
//''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

#ifndef CAMERALISTCLASS
#define CAMERALISTCLASS

#include <vector>
#include <Inventor/nodes/SoPerspectiveCamera.h>

using namespace std;

class SoPerspectiveCamera;

#define LERP(a,b,t) ( (1-(t))*(a) + (t)*(b) )

//------------------------------------------
// NOTE:
//
// only works with perspective cameras,
// for the time being.
//------------------------------------------

class CameraList {
  
  private:
  
  vector<SoPerspectiveCamera *> camlist;
  void solveTridiag(float sub[], float diag[], float sup[], float b[], int n);
  float cubicInterp(float y[], int np, float t);
    
  public:

  ~CameraList(){
    int numcams = camlist.size();
    for (int i=0; i<numcams; i++)
      (camlist[i])->unref();
    camlist.clear();
  }

  int numCams(){
    return camlist.size();
  }
  
  void addCamera(SoPerspectiveCamera *cam){
    cam->ref();
    camlist.push_back(cam);
  }
  
  int readList(string camFile);
  void positionCameraLinear(SoPerspectiveCamera *cam, float time=0.0);
  void positionCameraCubic(SoPerspectiveCamera *cam, float time=0.0);

};

#endif  /* CAMERALISTCLASS */
