// This procedurally defines a rotation
// and then dumps the .iv file format of it.
//
//  Author: Kevin Beason beason-at-cs.fsu.edu
//    Date: 5/21/2008
// Compile: g++ dumpRotation.cxx -o dumpRotation -lInventor

#include <Inventor/SbLinear.h>
#include <Inventor/SoOutput.h>
#include <Inventor/actions/SoWriteAction.h>
#include <Inventor/nodes/SoRotation.h>

int main(int argc, char *argv[]){

  SoDB::init();

  SoOutput *out = new SoOutput();
  out->setFilePointer(stderr);
  SoWriteAction *wa = new SoWriteAction(out);

  // calculate rotation
  SbVec3f lx(-10, 150, 110);
  SbVec3f vx(50,50,50);
  SbVec3f dir = vx-lx;
  SbRotation sbr;
  SbVec3f up(0,1,0);
  sbr.setValue(up, dir);
  
  SoRotation *rot = new SoRotation();
  rot->rotation = sbr;
  wa->apply(rot);

  return 0;
}
