// Title  : pfmtohdr
// Purpose: Converts portable float map (.pfm) file to Radiance format (.hdr)
// Usage  : pfmtohdr <infile.pfm> <outfile.hdr>
// Compile: g++ pfmtohdr.cxx -o obj/pfmtohdr obj/rgbe.o
// Author : Kevin Beason 6/26/07

#include <stdio.h>
#include <errno.h>
#include <iostream>
#ifdef __darwin__
#include <machine/endian.h>
#else
#include <endian.h>
#endif
#include "FileUtils.h"

using namespace std;

int main(int argc, char *argv[]){

  const bool verbose = false;
  
  if (argc<3) {
    printf("Usage: hdrtoexr <infile.hdr> <outfile.exr>\n",
           argv[0]);
    return 1;
  }

  int dim[2];
  float *image = FileUtils::readHDR(dim, argv[1]);
  if (!image){
    printf("Error reading HDR\n");
    return 1;
  }

  if (verbose) printf("Writing %s...", argv[2]);
  FileUtils::writeEXR(dim, argv[2], image);
  if (verbose) printf("done.\n");

  delete image;
  
  return 0;
}
