////////////////////////////////////////////////////////////////////////////
//
// File: intersect_ray_tri.cxx
// Description: Pane class (Core Ray Tracing Engine) header
// Created: 2003/07/17 09:33:17
// Author: Kevin Beason <beason@cs.fsu.edu>
//
// Copyright (c) 2003-2004 Kevin Beason
// 
// ray-triangle intersection subroutine
// for the Pane ray tracer.
// For more information on Pane, visit:
// http://www.csit.fsu.edu/~beason/pane/
// or see the accompanying documentation
// in the distribution.
//
// Quickly determines whether a given
// ray intersects a given triangle.
//
// This code is from
// http://www.ce.chalmers.se/staff/tomasm/raytri/raytri.c
// with slight modifications.
//
// $Id: intersect_ray_tri.h 1158 2007-05-11 06:18:18Z beason $
//
////////////////////////////////////////////////////////////////////////////

#ifndef INTERSECTRAYTRI
#define INTERSECTRAYTRI

#include <Inventor/SbLinear.h>

// Quickly determines whether a given
// ray intersects a given triangle.
int intersect_ray_tri(const SbVec3f &orig, const SbVec3f &dir,
		      const SbVec3f &vert0, const SbVec3f &vert1, const SbVec3f &vert2,
		      double *t, double *u, double *v);

#endif /* INTERSECTRAYTRI */
